<template>
    <section id="details-voiture" class="content">
            <page-header :title="entity.libelle">
                            <div slot="nav">
                <ol class="breadcrumb float-sm-right">
                       <li class="breadcrumb-item">
                           <router-link to="/voitures" class="">Voitures</router-link >
                        </li>
                       <li class="breadcrumb-item active">{{entity.libelle}}</li>
                </ol>
            </div>
            </page-header>
    <!-- Default box -->
    <div class="card">
        <div class="card-header">
          
                    <h3 class="card-title pl-2 d-flex" >
                                  <strong class="d-none">Statut</strong>   <span   class="btn btn-label-danger btn-sm btn-bold btn-upper d-inline-block w-100">Confirmé</span>
                       
                    </h3>

            <div class="card-tools">
                <a v-if="authorize('ajoute-location')" class="btn btn-primary text-white" @click.prevent="louer(entity)"><i class="fas fa-key mr-2"></i>Mettre en location</a>
            </div>
        </div>
    </div>
    <div class="row ">
        <div id="left" class="col-lg-4 col-md-12 col-sm-12 pl-0 pr-0 ">
                <div id="left-block-agile" class="col-md-12">
                    <button v-if="authorize('modifie-vehicule')" class="btn btn-xs btn-secondary update-photo" @click="callModalImages"> <i class="fa fa-camera"></i>  Modifier</button>
                     <div v-if="images.length <= 0 && !hasProfileImage">
                           <div class = "slide slide--3 agile__slide agile__slide--active agile__slide--current" style = "" >
                             <img src = "/storage/images/default.jpg" > 
                           </div>
                    </div>
                    <div v-else-if="images.length <= 0 && hasProfileImage">
                           <div class = "slide slide--3 agile__slide agile__slide--active agile__slide--current" style = "" >
                             <img :src = "'/storage/images/'+entity.image_mise_en_avant" > 
                           </div>
                    </div>
                    <div v-else>
                        <agile  class="main" ref="main" :options="options1" :as-nav-for="asNavFor1">
                            <div class="slide" v-for="(slide, index) in images" :key="index" :class="`slide--${index}`">
                                <img :src="slide"/>
                            </div>
                        </agile>
                        <agile   :class="['thumbnails', images.length < 3 ? 'gallery-thumbnails-no-slide': '' ]" ref="thumbnails" :options="options2" :as-nav-for="asNavFor2">
                            <div class="slide slide--thumbniail" v-for="(slide, index) in images" :key="index" :class="`slide--${index}`" @click="goTo(index)">
                                <img :src="slide"/>
                            </div>
                        <!--   <template slot="prevButton"><i class="fas fa-chevron-left"></i></template>-->
                        <!--   <template slot="nextButton"><i class="fas fa-chevron-right"></i></template>-->
                        </agile>
                    </div>
                </div>
                <div class="col-md-12">
                    <div id="left-donnee-generale" class="card mt-3">
                        <div class="card-header pl-0">
                            <h3 class="card-title ">
                                <button  type="button"  class="btn btn-tool" data-card-widget="collapse"><i class="fas fa-minus"></i>
                                </button>
                                 <b>Données générales</b>
                                 </h3>

                            <div class="card-tools">
                                <button v-if="authorize('modifie-vehicule')" class="btn btn-xs btn-secondary" @click="callModalDonneesGenerales">Modifier</button>
                            </div>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body p-0" style="display: block;">
                            <table class="table table-sm">
                                <tbody>
                                <tr>
                                    <td class="text-bold">Nom de code</td>
                                    <td>{{ entity.libelle }}</td>
                                </tr>
                                <tr>
                                    <td class="text-bold">Marque</td>
                                    <td>{{ entity.marque.libelle  }}</td>
                                </tr>
                                <tr>
                                    <td class="text-bold">Modele</td>
                                    <td>{{ entity.modele.libelle }}</td>
                                </tr>
                                <tr>
                                    <td class="text-bold">N° d'immatriculation</td>
                                    <td>{{ entity.plaque_immatriculation }} </td>
                                </tr>
                                <tr>
                                    <td class="text-bold">Type de voiture</td>
                                    <td>{{ entity.type_vehicule.libelle }} </td>
                                </tr>
                                <tr>
                                    <td class="text-bold">Couleur</td>
                                    <td>{{ entity.couleur }} </td>
                                </tr>

                                <tr>
                                    <td class="text-bold">Date de mise en service</td>
                                    <td>{{ entity.date_mise_en_circulation | toDate }}</td>
                                </tr>
                                <tr>
                                    <td class="text-bold">Transmission</td>
                                    <td>{{ entity.boite_vitesse }} </td>
                                </tr>
                                <tr>
                                    <td class="text-bold">Energie</td>
                                    <td>{{ entity.type_motorisation.libelle }}</td>
                                </tr>
                                <tr>
                                    <td class="text-bold">Consommation aux 100 km</td>
                                    <td>{{ entity.consommation_au_100_km }} L/Km</td>
                                </tr>
                                <tr>
                                    <td class="text-bold">Nombre de portes</td>
                                    <td class="text-bold">{{ entity.nbr_porte }} </td>
                                </tr>
                                <tr>
                                    <td class="text-bold">Nombre de places</td>
                                    <td>{{ entity.nbr_place }} </td>
                                </tr>

                                <tr>
                                    <td class="text-bold">N° de Chassis</td>
                                    <td>{{ entity.nr_chassis }}</td>
                                </tr>

                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
                <div class="col-md-12">
                    <div id="left-donnee-generale" class="card mt-3">
                        <div class="card-header pl-0">
                            <h3 class="card-title ">
                                <button type="button"  class="btn btn-tool" data-card-widget="collapse"><i class="fas fa-plus"></i>
                                </button>
                                 <b>Volume et Dimensions </b>
                                 </h3>

                            <div class="card-tools">
                                <button v-if="authorize('modifie-vehicule')"  class="btn btn-xs btn-secondary" @click="callModalDonneesPhysiques">Modifier</button>
                            </div>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body p-0" style="display: none;">
                            <table class="table table-sm">
                                <tbody>
                                <tr>
                                    <td class="text-bold">Volume du coffre</td>
                                    <td>
                                        
                                        <span v-if="entity.volume_coffre!=null">{{ entity.volume_coffre }} L  </span>
                                        <span v-else> Non précisé </span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="text-bold">Volume du réservoir</td>
                                    <td>
                                        <span v-if="entity.volume_reservoir!=null">{{ entity.volume_reservoir }} L </span>
                                        <span v-else> Non précisé </span>


                                    </td>
                                </tr>
                                 <tr>
                                    <td class="text-bold">Poids de la voiture</td>
                                    <td>
                                          <span v-if=" entity.poids != null ">{{ entity.poids }} Kg </span>
                                          <span v-else> Non précisé </span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="text-bold">Dimensions (L x l x H ) en m</td>
                                    <td> {{ entity.longueur!=null ? entity.longueur : '-'}} x {{ entity.largeur!=null ? entity.largeur : '-'}} x {{ entity.hauteur!=null ? entity.hauteur : '-'}} </td>
                                </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
                <div class="col-md-12">
                    <div id="left-options" class="card mt-3">
                        <div class="card-header pl-0">
                            <h3 class="card-title">
                                 <button  type="button" class="btn btn-tool" data-card-widget="collapse"><i class="fas fa-plus"></i>
                                </button>
                                <b>Options</b></h3>

                            <div class="card-tools">
                                <button v-if="authorize('modifie-vehicule')"  @click="callModalDonneesOptions" class="btn btn-xs btn-secondary">Modifier</button>
                            </div>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body p-0" style="display:none;">
                            <table class="table table-sm">
                                <tbody>
                                <tr >
                                    <td>
                                        <span style="background: #737373 !important;"  v-for="option in entity.options" :key="option.id"  class="multiselect__tag"><span v-text="option.libelle"></span></span>
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>  
                </div>
        </div>
        <div id="right"  class="col-lg-8 col-md-12 col-sm-12">
            <div class="card card-primary card-outline card-outline-tabs car-tab-custom">
                <div class="card-header p-0 border-bottom-0 car-tab-custom-header">
                    <ul class="nav nav-tabs" id="nav-details-voiture" role="tablist">
                        <li class="nav-item">
                            <a class="nav-link active" id="custom-tabs-three-settings-tab" data-toggle="pill" href="#custom-tabs-three-locations" role="tab" aria-controls="custom-tabs-three-locations" aria-selected="false">Locations (<span v-text="entity.locations.length"></span>) </a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" id="custom-tabs-three-visites-tab" data-toggle="pill" href="#custom-tabs-three-documents" role="tab" aria-controls="custom-tabs-three-documents" aria-selected="false">Documents</a>
                        </li>
                    </ul>
                </div>
                <div class="card-body pl-2 pr-2">
                    <div class="tab-content" id="custom-tabs-three-tabContent">
                        <div class="tab-pane fade " id="custom-tabs-three-finances" role="tabpanel" aria-labelledby="custom-tabs-three-home-tab">
                        </div>
                        <div class="tab-pane fade active show" id="custom-tabs-three-locations" role="tabpanel" aria-labelledby="custom-tabs-three-profile-tab">
                           <location-grid ref="locationsvue" :entity="entity" :is-set="true" v-if="entity_ready"></location-grid>
                        </div>
                        <div class="tab-pane fade" id="custom-tabs-three-documents" role="tabpanel" aria-labelledby="custom-tabs-three-documents-tab">
                           <document-grid :entity="entity" ></document-grid>
                        </div>
                    </div>
                </div>
                <!-- /.card -->
            </div>
        </div>

    </div>

        <mettre-en-location v-show="true"  @mise-en-location-event="updateLocation"></mettre-en-location>
        <donnees-generales  v-show="true"></donnees-generales>
        <donnees-options v-show="true" ></donnees-options>
        <donnees-physiques v-show="true" ></donnees-physiques>
        <donnees-images v-show="true"></donnees-images>
    <!-- /.card -->

</section>
</template>
<script>

   import Form from "./../../classes/Form"
   import Master from "./../Master.vue";
   import { VueAgile } from 'vue-agile';
   import  LocationGrid from './../../components/LocationGrid';
   import  DocumentGrid from './../../components/DocumentGrid';
   import  FinanceGrid from './../../components/FinanceGrid';

   import MettreEnLocation from "./../../components/MettreEnLocation.vue";
   import DonneesGenerales from "./ModalDonneesGenerales.vue";
   import DonneesPhysiques from "./ModalDonneesPhysiques.vue";
   import DonneesOptions from "./ModalDonneesOptions.vue";
   import DonneesImages from "./ModalImages.vue";

    export default {
        mixins: [Master],
        data()
          {
            return{
                options: 
                {
                    assureurs : []
                },
                isLoading:false,
                entity:{
                    modele:{},
                    marque:{},
                    images:[],
                    type_motorisation:{},
                    type_vehicule:{}
                },
                init:true,
                currentYear:2010,
                			asNavFor1: [],
			asNavFor2: [],
			options1: {
				dots: false,
				fade: true,
				navButtons: false
			},

			options2: {
				autoplay: false,
				centerMode: true,
				dots: false,
				navButtons: false,
				slidesToShow: 4,
				responsive: [
                {
                    breakpoint: 600,
                    settings: {
                        slidesToShow: 5
                    }
                },

                {
                    breakpoint: 1000,
                    settings: {
                        navButtons: true
                    }
                }
            ]},
            slides: [

				]

         }
        },
        mounted() {

            window.addEventListener('load', () => {
                           this.pageInit = true
            this.currentYear = moment().format('YYYY')
            this.asNavFor1.push(this.$refs.thumbnails)
            this.asNavFor2.push(this.$refs.main)

            window.event.$on('updated-physique-event',(vehicule) =>
                {
                    this.entity = vehicule
                })
            window.event.$on('updated-general-data-event',(vehicule) =>
                {
                    this.entity = vehicule
                })
            window.event.$on('updated-options-event',(vehicule) =>
            {
                this.entity = vehicule
            })
            window.event.$on('profile-updated-event',(response) =>
            {
                if(response.images.length<=0)
                {
                  this.entity.image_mise_en_avant  =response.profile
                  this.$forceUpdate();
                }
                
               this.$nextTick(() => 
               {
                if(this.$refs.main )
                    this.$refs.main.reload();
                    // if( this.$refs.thumbnails)
                    //  this.$refs.thumbnails.reload();
                });
            })

            window.event.$on('gallery-updated-event',(response) =>
            {
              this.options2.slidesToShow=response.images.length
              // Stop gallery thumbnails sliding if < 5

                if(isDefined(response.profile))
                {
                   this.entity.image_mise_en_avant  =response.profile
                   //this.$forceUpdate();
                }
                
               this.entity.images = response.images
               this.options2.infinite = true
                
                this.$nextTick(() => {
                    //console.log(this.$refs.main,rzimages)
                    // if(this.$refs.main )
                    //   this.$refs.main.reload();
                    // if( this.$refs.thumbnails)
                    //  this.$refs.thumbnails.reload();
                });
            })
            })


        },

        created(){

               axios.get("/api/vehicules/"+this.$route.params.id).then((response) =>
                {

                       this.entity = response.data
                       var count =this.entity.image_mise_en_avant!=null ? this.entity.images.length+1 : this.entity.images.length
                      
                     this.options2.infinite = true
                      window.event.$emit("isLoading",false)
                       if(this.init==true)
                        {
                          this.init =false
                        }
                        if(this.pageInit==false)
                        {
                            this.pageInit =true
                        }

                },
                (error) => {
                         console.log("Promise Rejected:")

                });
        },
        computed:
        {
             years ()
             {
                const year = new Date().getFullYear()
                return Array.from({length: 10}, (value, index) => (year) - index)
            },
            entity_ready()
             {
                if(this.entity!=null && this.entity!=undefined && this.entity!="")
                  return true
                else
                  return false
            },
            hasProfileImage()
             {
                 if(this.entity_ready)
                 {
                        return  this.entity.image_mise_en_avant != null && this.entity.image_mise_en_avant != ""
                 }
                 else
                 return false
            },
            images()
            {
                var slides = []
                if(this.entity_ready)
                {
                    //On retire les images qui pourraient manquer de chemin
                   var fil = this.entity.images.filter(e => { return e.chemin!=null})
                   //on ajoute les données de fichiers de stockage
                   slides = this.entity.images.map(e => '/storage/images/'+e.chemin)
                   //Si on a une photo de photo
                   if(this.hasProfileImage)
                   {
                       if(slides.length>0)
                       //alors, on l'insere
                       slides.unshift('/storage/images/'+this.entity.image_mise_en_avant)
                   }
                  if(!this.hasProfileImage && slides.length>0 )
                   {
                       //alors, on l'insere
                       slides.unshift('/storage/images/default.jpg')
                   }
                }
                return slides
            },

        },
        methods:
        {

           goTo(index)
           {
                this.$refs.thumbnails.goTo(index)
                this.$refs.main.goTo(index)
           },

            ActualiseAssurance()
            {
                window.event.$emit('update-assurance-event')
            },

             //Met un vehicule en location
             louer(entity)
             {
               window.event.$emit('mettre-en-location-event',entity)
             },
            //Met un vehicule en location
            updateLocation(e)
            {
               this.$refs.locationsvue.locations.unshift(e)
            },

            //appel du formulaire pour changer les données générales
            callModalDonneesGenerales()
            {
              window.event.$emit('change-general-data-event',this.entity)
            }
            ,
            //appel du formulaire pour changer les données options
            callModalDonneesOptions()
            {
                window.event.$emit('change-options-event',this.entity)
            },
            //appel du formulaire pour changer les données physiques du véhicule
            callModalDonneesPhysiques()
            {
                window.event.$emit('change-physique-event',this.entity)
            },
                        //appel du formulaire pour changer les données physiques du véhicule
            callModalImages()
            {
                var obj = {
                    image_mise_en_avant:this.entity.image_mise_en_avant,
                    id:this.entity.id,
                    images:this.entity.images.map(e =>e.chemin)
                }
                window.event.$emit('change-images-event',obj)
            }
        },
        watch: {
            images() {
 
            }
        },
        components:
        {
          agile: VueAgile,
          DonneesGenerales,
          DonneesOptions,
          DonneesPhysiques,
          DonneesImages,
          LocationGrid,
          DocumentGrid,
          MettreEnLocation,
          FinanceGrid
	    }
    }
</script>
<style lang="scss" >
    .agile__actions {
        display: none !important;
    }
    #left-block-agile
    {
        position: relative;
    }
    button.update-photo
    {
        position: absolute;
        z-index: 2;
        top: 5px;
        right: 15px;
        background-color: #6c757d75;
        border-color: #6c757d94;
    }
   .main .slide img {
    height: 333px;
    -o-object-fit: cover;
    object-fit: cover;
    -o-object-position: center;
    object-position: center;
    width: 100%;
}
.left-block-agile
{
    min-height: 273px;
}
// Infinite = false doesn't actually stop the gallery sliding out of view. Prevent that behaviour here
.gallery-thumbnails-no-slide::v-deep .agile__track {
  transform: none !important;
}
</style>
